''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright www.acecomputing.biz
' Feel free to use and modify this code for private use.
' Not licensed for resale
'''''''''''''''''''''''''''''''''''''''''''''''''''

Public Class Cell
    Public ReadOnly _copyrightAceComputing As String = "www.acecomputing.biz"
    Private _textArea As TextArea
    Private _height As Integer ' PDFUnits
    Private _colSpan As Integer = 1
    Private _widthPercent As Integer = 0
    Private _widthPDFUnits As Integer
    Private _StartH As Integer      ' Start of text
    Private _StartV As Integer
    ' Private _align As Alignments = Alignments.leftAlign

    Public Sub New()
        _textArea = New TextArea()
        _colSpan = 1
    End Sub

    Function getCopy() As Cell
        Dim myCell As Cell, myText As TextObject
        myCell = New Cell()
        With myCell
            '.Align = Me._align
            For Each myText In _textArea.getTexts
                .AddText(myText.Text, myText.Font, myText.FontSize, myText.FontStyle)
            Next
            .ColumnSpan = _colSpan
        End With
        Return myCell
    End Function

    'Public Property Align() As Alignments
    '    Get
    '        Return _align
    '    End Get
    '    Set(ByVal myAlign As Alignments)
    '        Select Case myAlign
    '            Case Alignments.center
    '            Case Alignments.leftAlign
    '            Case Alignments.rightAlign
    '            Case Else
    '                Throw New Exception("Invalid Alignment")
    '        End Select
    '        _align = myAlign
    '    End Set
    'End Property

    Function Draw(ByRef FontAlias As Hashtable, ByRef pagenum As Integer, ByVal TopMargin As Integer) As PDFObject
        _textArea.StartPDFH = _StartH
        Return _textArea.Draw(_StartV, _widthPDFUnits, FontAlias, pagenum, TopMargin)
    End Function

    Property StartPDFH() As Integer
        Get
            Return _StartH
        End Get
        Set(ByVal startH As Integer)
            If startH < 1 Then
                Throw New Exception("Invalid horizontal coordinate for cell.")
            End If
            _StartH = startH
        End Set
    End Property

    Property StartPDFV() As Integer
        Get
            Return _StartV
        End Get
        Set(ByVal startV As Integer)
            If startV < 1 Then
                Throw New Exception("Invalid vertical coordinate for cell.")
            End If
            _StartV = startV
        End Set
    End Property

    Property WidthInPercent() As Integer
        Get
            Return _widthPercent
        End Get
        Set(ByVal widthPercent As Integer)
            If widthPercent < 0 Then
                Throw New Exception("Invalid cell width.")
            End If
            _widthPercent = widthPercent
        End Set
    End Property

    Property WidthInPDFUnits() As Integer
        Get
            Return _widthPDFUnits
        End Get
        Set(ByVal widthPDFUnits As Integer)
            If widthPDFUnits < 0 Then
                Throw New Exception("Invalid cell width.")
            End If
            _widthPDFUnits = widthPDFUnits
        End Set
    End Property

    Public Property ColumnSpan() As Integer
        Get
            Return _colSpan
        End Get
        Set(ByVal ColSpan As Integer)
            If ColSpan < 1 Then
                Throw New Exception("Invalid Column Span.")
            End If
            _colSpan = ColSpan
        End Set
    End Property

    Public Sub AddText(ByVal Text As String, Optional ByVal Font As Fonts = Fonts.Helvetica, _
        Optional ByVal fontSize As Integer = 10, Optional ByVal FontStyle As FontStyles = FontStyles.Regular)
        _textArea.AddText(Text, Font, fontSize, FontStyle)
    End Sub

    Function calculateHeight(ByVal width As Integer) As Integer
        _widthPDFUnits = width
        _textArea.CalculateHeight(width)
        _height = _textArea.HeightInPDFunits
        calculateHeight = _height
    End Function

End Class
