''''''''''''''''''''''''''''''''''''''''''''''''''
' Copyright www.acecomputing.biz
' Feel free to use and modify this code for private use.
' Not licensed for resale
'''''''''''''''''''''''''''''''''''''''''''''''''''
Public Enum Fonts
    Helvetica = 0       ' Adobe font
    Courier = 1         ' Adobe font
    Times_Roman = 2     ' Adobe font
    Symbol = 3          ' Adobe font
    ZapfDingBats = 4    ' Adobe font
    ' Arial_Narrow = 5    ' Windows font
End Enum

Public Enum FontStyles
    Regular = 0
    Bold = 1
    Italic = 2
    BoldItalic = 3
End Enum

Public Class FontObj
    Public ReadOnly _copyrightAceComputing As String = "www.acecomputing.biz"
    Dim _Font As Fonts = Fonts.Helvetica
    Dim _FontName As String = ""
    Dim _FontRef As String = ""
    Dim _fontObj As String  ' A reference to a fontobject in the PDF files
    Dim _fontStyle As FontStyles = FontStyles.Regular

    Public Sub New()
        _Font = Fonts.Helvetica
        _FontName = ""
    End Sub

    Overloads Function equals(ByVal fontObj As FontObj) As Boolean
        equals = True
        If _Font <> fontObj.Font Or _fontStyle <> fontObj.FontStyle Then
            equals = False
        Else
            equals = True
        End If
    End Function

    Public Property FontStyle() As FontStyles
        Get
            Return _fontStyle
        End Get
        Set(ByVal myFontStyle As FontStyles)
            _fontStyle = myFontStyle
            Call SetFontName()
        End Set
    End Property

    Public Property FontRef() As String
        Get
            Return _FontRef
        End Get
        Set(ByVal Value As String)
            _FontRef = Value
        End Set
    End Property

    Public Property FontObj() As String
        Get
            Return _fontObj
        End Get
        Set(ByVal Value As String)
            _fontObj = Value
        End Set
    End Property

    Public Function ValidFont(ByVal font As Fonts) As Boolean
        If -1 < font And font < 5 Then
            ValidFont = True
        Else
            ValidFont = False
        End If
    End Function

    Public ReadOnly Property HorizontalSpace() As Decimal
        Get
            Dim space As Decimal
            Select Case _Font
                Case Fonts.Courier
                    space = 1.7
                Case Fonts.Helvetica
                    space = 2.2
                Case Fonts.Times_Roman
                    space = 2.4
                Case Else
                    space = 2
            End Select
            If Me._fontStyle = FontStyles.Bold Or Me._fontStyle = FontStyles.BoldItalic Then
                space *= 0.91
            End If
            Return space
        End Get
    End Property

    Public Property Font() As Fonts
        Get
            Return _Font
        End Get
        Set(ByVal myFont As Fonts)
            _Font = myFont
            Call SetFontName()
        End Set
    End Property

    Private Sub SetFontName()
        Select Case _Font
            Case Fonts.Courier
                Select Case _fontStyle
                    Case FontStyles.Regular
                        _FontName = "Courier"
                    Case FontStyles.Bold
                        _FontName = "Courier-Bold"
                    Case FontStyles.Italic
                        _FontName = "Courier-Oblique"
                    Case FontStyles.BoldItalic
                        _FontName = "Courier-BoldOblique"
                    Case Else
                        Throw New Exception("Invalid Font style.")
                End Select
            Case Fonts.Helvetica
                Select Case _fontStyle
                    Case FontStyles.Regular
                        _FontName = "Helvetica"
                    Case FontStyles.Bold
                        _FontName = "Helvetica-Bold"
                    Case FontStyles.Italic
                        _FontName = "Helvetica-Oblique"
                    Case FontStyles.BoldItalic
                        _FontName = "Helvetica-BoldOblique"
                    Case Else
                        Throw New Exception("Invalid Font style.")
                End Select
            Case Fonts.Times_Roman
                Select Case _fontStyle
                    Case FontStyles.Regular
                        _FontName = "Times-Roman"
                    Case FontStyles.Bold
                        _FontName = "Times-Bold"
                    Case FontStyles.Italic
                        _FontName = "Times-Italic"
                    Case FontStyles.BoldItalic
                        _FontName = "Times-BoldItalic"
                    Case Else
                        Throw New Exception("Invalid Font style.")
                End Select
            Case Fonts.Symbol
                _FontName = "Symbol"
            Case Fonts.ZapfDingBats
                _FontName = "ZapfDingBats"
            Case Else
                Throw New Exception("Invalid Font")
        End Select
    End Sub

    Public ReadOnly Property FontName() As String
        Get
            Return _FontName
        End Get
    End Property

End Class
'Public Enum Color
'    cAqua = 255255              ' 00FFFF; corresponding Hexadecimal value used in HTML
'    cblack = 0                  ' 000000
'    cBlue = 255                 ' 0000FF
'    cFuchsia = 255000255        ' FF00FF
'    cGray = 128128128           ' 808080
'    cGreen = 128000             ' 008000
'    cLime = 255000              ' 00FF00
'    cMaroon = 128000000         ' 800000
'    cNavy = 128                 ' 000080
'    cOlive = 128128000          ' 808000
'    cPurple = 128000128         ' 800080
'    cSilver = 192192192         ' C0C0C0
'    cred = 255000000            ' FF0000
'    cWhite = 255255255          ' FFFFFF
'    cYellow = 255255000         ' FFFF00
'    cTeal = 128128              ' 008080
'End Enum
